<template>
    <div>
        <svg-icons/>
        <site-header/>

        <div class="site-content">
            <div class="container">
                <div class="site-layout">
                    <sidebar where="left">
                        <sidebar-left/>
                    </sidebar>
                    <main class="main layout-content">
                        <a
                            v-if="topBanner !== {}"
                            @click="registerBannerClick(topBanner.id)"
                            :href="topBanner.link"
                            target="_blank"
                            class="header-banner"
                        >
                            <img class="img" :src="`/storage/${topBanner.img}`" alt />
                        </a>
                        <content-tabs/>
                        <breadcrumbs :breadcrumbs="breadcrumbsFormatted"/>

                        <router-view/>
                    </main>
                    <sidebar where="right">
                        <sidebar-right/>
                    </sidebar>
                </div>
            </div>
        </div>

        <site-footer/>
    </div>
</template>

<script>
import SvgIcons from './components/SvgIcons'
import SiteHeader from './components/header/SiteHeader'
import ContentTabs from './components/ContentTabs'
import SidebarLeft from './components/sidebar/SidebarLeft'
import SidebarRight from './components/sidebar/SidebarRight'
import SiteFooter from './components/SiteFooter'
import matchStats from './components/pageparts/match/MatchStats'
import Sidebar from './components/sidebar/Sidebar'
import Breadcrumbs from "./components/Breadcrumbs";

import {mapActions, mapGetters} from 'vuex'

import Api from './JokerApi'

const api = new Api

export default {
    name: 'app',
    computed: {
        ...mapGetters(['trackerItems', 'banners', 'match'])
    },
    data() {
        return {
            breadcrumbs: [],
            breadcrumbsFormatted: [],
            currentLeagueName: '',
            currentMatchName: '',
            currentLeagueId: '',
            currentLeagueMatchName: '',
            topBanner: {}
        }
    },
    components: {
        SvgIcons,
        SiteHeader,
        SiteFooter,
        ContentTabs,
        SidebarLeft,
        SidebarRight,
        Sidebar,
        Breadcrumbs,
    },
    watch: {
        $route: {
            immediate: true,
            handler(to, from) {
                document.title = to.meta.title || 'JokerOdds';
                this.breadcrumbs = this.$route.meta.breadcrumbs
                this.$forceUpdate()
            }
        },
        currentLeagueName() {
            this.formatBreadcrumbs();
        },
        currentLeagueId() {
            this.formatBreadcrumbs();
        },
        currentMatchName() {
            this.formatBreadcrumbs();
        },
        currentLeagueMatchName() {
            this.formatBreadcrumbs();
        },
        breadcrumbs() {
            this.formatBreadcrumbs();
        }
    },
    methods: {
        ...mapActions(['fetchTrackerItems', 'fetchBanners', 'replaceAverage']),
        async processCookieToken() {
            if (!this.$cookies.get('api_remember_token')) {
                let key = await api.getCookieToken()
                this.$log.debug('new api_remember_token set from api', key)
                this.$cookies.set('api_remember_token', key)
            } else {
                this.$log.debug('api_remember_token from cookies', this.$cookies.get('api_remember_token'))
            }
        },

        async getTrackerItems() {
            const remember_token = this.$cookies.get('api_remember_token')
            await this.fetchTrackerItems(remember_token)
        },
        async getBanners() {
            await this.fetchBanners()
            this.$log.debug('banners', this.banners)
        },
        async registerBannerClick(id) {
            const status = await api.registerBannerClick(id)
            this.$log.debug('registerBannerClick', id, status)
        },


        formatBreadcrumbs() {
            if (!this.breadcrumbs?.items) {
                return
            }
            let result = this.breadcrumbs?.items
            let type = this.breadcrumbs?.pageType;
            let formatted = result.map((item) => {
                let newName = '';
                let newId = '';
                if (!item.name.length) {
                    if (type === 'league') {
                        newName =
                            item.type === 'league'
                                ? this.currentLeagueName
                                : this.currentMatchName

                        return {...item, name: newName}

                    }
                    if (type === 'match') {
                        newName =
                            item.type === 'match'
                                ? this.currentMatchName
                                : this.currentLeagueMatchName
                        newId =
                            item.type === 'league'
                                ? `/football/league/${this.currentLeagueId}`
                                : ''
                        return {...item, name: newName, path: newId}

                    }
                }
                return item

            })
            this.breadcrumbsFormatted = formatted;
            this.$forceUpdate()
        }
    },
    mounted() {
        Promise.all([
            this.processCookieToken(),
            this.getTrackerItems(),
            this.getBanners()
        ]).then(() => {
            this.$log.debug('this.trackerItems', this.trackerItems)
            this.$log.debug('this.banners', this.banners)
            this.$root.$emit('getBanners', this.banners)
            this.$root.$emit('getTrackerItems', this.trackerItems)
        })
        this.$root.$on('updateTrackerItems', () => {
            this.getTrackerItems().then(() => {
                this.$root.$emit('getTrackerItems', this.trackerItems)
            })
        })

        this.$root.$on('removeTrackerItem', ({event_id, market_id, name,line}) => {
            const remember_token = this.$cookies.get('api_remember_token')
            api.removeTrackerItem(remember_token, event_id, market_id, name,line).then(() => {
                this.$root.$emit('updateTrackerItems')
                this.$root.$emit('getTrackerItems', this.trackerItems)
            })
        })

        this.$root.$on('clearTrackerItems', () => {
            const remember_token = this.$cookies.get('api_remember_token')
            api.removeAllTrackerItems(remember_token).then(() => {
                this.$root.$emit('updateTrackerItems')
                this.$root.$emit('getTrackerItems', this.trackerItems)
            })
        })

        this.$root.$on('registerBannerClick', (id) => {
            this.registerBannerClick(id)
        })

        this.$root.$on('setLeagueName', (name) => {
            this.currentLeagueName = name;
            this.$forceUpdate()

        })
        this.$root.$on('setLeagueId', (id) => {
            this.currentLeagueId = id;
            this.$forceUpdate()


        })
        this.$root.$on('setLeagueMatchName', (league_match_name) => {
            this.currentLeagueMatchName = league_match_name;
            this.$forceUpdate()

        })
        this.$root.$on('setMatchName', (match_name) => {
            this.currentMatchName = match_name;
            this.$forceUpdate()


        })
        this.$root.$on('getBanners', (banners) => {
            if (banners.top[0]) {
                this.topBanner = banners.top[0]
            }
        })
        if (this.$cookies.get('getAverage')) {
            let cookieAverage = this.$cookies.get('getAverage')
            this.replaceAverage(cookieAverage)
        }

    }
}
</script>

<style lang="scss">

</style>
